// Turtle class from Mary Johnson, Ian Hagemann, and Tom Dixon, summer 98
// Adapted for CMUGraphics by Charles Brewer.
//
// C calls added for a non-OO turtle by JLK, Dec 2001.
//--------------------------------------------------------------------
//
//  provides operations for a "turtle"               turtle.h
//
//--------------------------------------------------------------------


// Declaration for a "Turtle" class.
#include <CMUgraphics.h>

class Turtle
{
public:         // Member functions

 // Constructors
   Turtle (window & win, int xCoord, int yCoord, int head); // Define a Turtle
   Turtle (window & win, int xCoord, int yCoord);           // Define Turtle at
   Turtle (window & win);                                   // Default constructor
   ~Turtle();
   void forward (int amt);    // move the Turtle amt steps forward; drawing a
                                     // line in pencolor if the pen is down.
   void back (int amt);       // move the Turtle back amt steps; drawing a
                                     // line in pencolor if the pen is down.
   void turnRight (int amt);  // turn the Turtle to the right amt degrees.
   void turnLeft (int amt);   // turn the Turtle to the left amt degrees.
   void home ();              // move the Turtle to the home position -
                                     // center of the screen, facing north.
   void clear ();             // clear screen; position and direction of
                                     //  Turtle unchanged.
   void clearAll ();          // clear screen; move Turtle to home position.
   void penColor (color kolor); // change pen color to the color indicated.
   void penColor (int icolor);  // change pen color (1 - BLACK, 2 - GRAY,
                                // 3 - BLUE,    4 - RED,    5 - GREEN, 
                                // 6 - YELLOW,  7 - ORANGE, 8 - CYAN, 
                                // 9 - MAGENTA, 10 - WHITE)
   void penUp ();               // pen up - no lines will be drawn.
   void penDown ();             // pen down - lines will be drawn.

private:           // Data members
   window &TWindow;      // turtle window
   int heading,          // direction of Turtle
   x, y,                 // coordinates of Turtle
   pen;                  // pen up or down
   color Color;          // color of Turtle
};

// -------------------------------------------------------------------------
// Procedural (C) turtle graphics function prototypes 
// Only one turtle is created.

void createTurtle(window &win); // must call before working with Turtle.
 
void forward (int amt);      // move the Turtle amt steps forward; drawing a
                             // line in pencolor if the pen is down.
void back (int amt);         // move the Turtle back amt steps; drawing a
                             // line in pencolor if the pen is down.
void turnRight (int amt);    // turn the Turtle to the right amt degrees.
void turnLeft (int amt);     // turn the Turtle to the left amt degrees.
void home ();                // move the Turtle to the home position -
                             // center of the screen, facing north.
void clear ();               // clear screen; position and direction of
                             //  Turtle unchanged.
void clearAll ();            // clear screen; move Turtle to home position.
void penColor (color kolor); // change pen color to the color indicated.
void penColor (int icolor);  // change pen color (1 - BLACK, 2 - GRAY,
                             // 3 - BLUE, 4 - RED, 5 - GREEN, 6 - YELLOW,
                             // 7 - ORANGE, 8 - CYAN, 9 - MAGENTA,
                             // 10 - WHITE)
void penUp ();               // pen up - no lines will be drawn.
void penDown ();             // pen down - lines will be drawn.
